# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

# motion.h File Reference

`#include <libdirac_common/common.h>`
`#include <algorithm>`

Go to the source code of this file.

## Classes

- class dirac::MotionVector< T >
    Motion vector class - just a pair. More...
- class dirac::MvCostData
    Class for recording costs derived in motion estimation. More...
- class dirac::MvData
    Class for all the motion vector data. More...
- class dirac::MEData
    Class for all the motion estimation data. More...

## Namespaces

- namespace dirac

    Definition of class SequenceHeaderByteIO.

## Typedefs

- typedef MotionVector< int > dirac::MVector
    MVector class is a vector of ints.
- typedef MotionVector< int > dirac::ImageCoords
    ImageCoords class is a vector of ints.
- typedef TwoDArray< MVector > dirac::MvArray
    MvArray is a two-D array of MVectors.
- typedef TwoDArray
  < MotionVector< float > > dirac::MvFloatArray
    An array of float-based motion vectors for doing global motion calcs.

## Enumerations

- enum dirac::MvElement { dirac::HORIZONTAL, dirac::VERTICAL }

    Horizontal or vertical.

    More...

## Functions

- template<class T > std::ostream & dirac::operator<< (std::ostream &stream, MotionVector< T > &mv)
    Overloaded operator<< for MotionVector class for output to stream.
- template<class T > std::istream & dirac::operator>> (std::istream &stream, MotionVector< T > &mv)
    Overloaded operator>> for MotionVector class for input from stream.
- int dirac::Median (const int val1, const int val2, const int val3)
    Return the median of 3 integers.
- MVector dirac::MvMedian (const MVector &mv1, const MVector &mv2, const MVector &mv3)
    Return the median of three motion vectors.
- int dirac::Median (const std::vector< int > &val_list)
    Return the median of a set of integers.
- MVector dirac::MvMedian (const std::vector< MVector > &vect_list)
    Return the median of a set of (up to 4) motion vectors.
- MVector dirac::MvMean (const MVector &mv1, const MVector &mv2)
    Return the mean of two motion vectors.
- int dirac::Norm2 (const MVector &mv)
    Return the squared length of a motion vector.
- int dirac::Norm1 (const MVector &mv)
    Return the sum of the lengths of a motion vector's componets.
- unsigned int dirac::GetUMean (std::vector< unsigned int > &values)
    Return the mean of a set of unsigned integer values.
- int dirac::GetSMean (std::vector< int > &values)
    Return the mean of a set of signed integer values.

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.